/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ufos2;

import java.awt.Color;
import java.awt.Graphics;

/**
 *
 * @author pinter
 */
public class UFO {

    private double x;
    private double y;

    private double velx;
    private double vely;

    private Color color;

    private UFOPanel ufoPanel;

    private final double VELOCITY_RANGE = 3;

    private final int UFOBODY_WIDTH = 40;
    private final int UFOBODY_HEIGHT = 20;
    private final int UFOCABIN_RADIUS = 16;

    public UFO(UFOPanel ufoPanel) {
        this.ufoPanel = ufoPanel;
        x = Math.random() * ufoPanel.getWidth();
        y = Math.random() * ufoPanel.getHeight();
        velx = Math.random() * VELOCITY_RANGE * 2 - VELOCITY_RANGE;
        vely = Math.random() * VELOCITY_RANGE * 2 - VELOCITY_RANGE;
        color = new Color((float) Math.random(), (float) Math.random(),
                (float) Math.random());
    }

    public void move() {
        x += velx;
        y += vely;
        if (x < 0) {
            x = ufoPanel.getWidth();
        }
        if (x > ufoPanel.getWidth()) {
            x = 0;
        }
        if (y < 0) {
            y = ufoPanel.getHeight();
        }
        if (y > ufoPanel.getHeight()) {
            y = 0;
        }
    }

    public void draw(Graphics g) {
        g.setColor(color);
        g.fillOval((int) x, (int) y, UFOBODY_WIDTH, UFOBODY_HEIGHT);
        g.setColor(color.darker());
        g.fillOval((int)(x + (UFOBODY_WIDTH-UFOCABIN_RADIUS)/2),
                (int) (y - UFOCABIN_RADIUS/2), UFOCABIN_RADIUS, UFOCABIN_RADIUS);
    }

    public void setPosition(double x, double y) {
        this.x = x;
        this.y = y;
    }

    public void updateColor() {
        color = new Color((float) Math.random(), (float) Math.random(),
                (float) Math.random());
    }
}
