/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ufos2;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.Timer;

/**
 *
 * @author pinter
 */
public class UFOGUI {

    private JFrame frame;
    private UFOPanel ufoPanel;
    private JPanel buttonPanel;

    private ArrayList<UFO> ufos = new ArrayList<>();
    
    private int DRAWAREA_WIDTH = 1000;
    private int DRAWAREA_HEIGHT = 500;

    public UFOGUI() {
        frame = new JFrame();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        buttonPanel = new JPanel();
        int[] addedUFOs = new int[]{-1000, -100, -10, -1, 1, 10, 100, 1000};
        for (int num : addedUFOs) {
            JButton button = new JButton(String.valueOf(num));
            button.addActionListener(new AddRemoveUFOsListener(num));
            buttonPanel.add(button);
        }
        frame.getContentPane().add(buttonPanel, BorderLayout.SOUTH);

        ufoPanel = new UFOPanel(ufos);
        ufoPanel.setPreferredSize(new Dimension(DRAWAREA_WIDTH, DRAWAREA_HEIGHT));
        ufoPanel.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {

            }

            @Override
            public void mousePressed(MouseEvent e) {

            }

            @Override
            public void mouseReleased(MouseEvent e) {
                for (UFO ufo : ufos) {
                    ufo.setPosition(e.getX(), e.getY());
                }
            }

            @Override
            public void mouseEntered(MouseEvent e) {

            }

            @Override
            public void mouseExited(MouseEvent e) {

            }
        });
        frame.getContentPane().add(ufoPanel, BorderLayout.CENTER);

        Timer timer = new Timer(10, new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                for (UFO ufo : ufos) {
                    ufo.move();
                    if (Math.random() < 1e-2) {
                        ufo.updateColor();
                    }
                }
                ufoPanel.repaint();
            }
        });
        timer.start();

        frame.pack();
        frame.setVisible(true);
    }

    class AddRemoveUFOsListener implements ActionListener {

        private int num;

        public AddRemoveUFOsListener(int num) {
            this.num = num;
        }

        @Override
        public void actionPerformed(ActionEvent e) {
            if (num > 0) {
                for (int i = 0; i < num; ++i) {
                    ufos.add(new UFO(ufoPanel));
                }
            } else {
                for (int i = num; i < 0; ++i) {
                    if (!ufos.isEmpty()) {
                        ufos.remove(ufos.size() - 1);
                    }
                }
            }
        }

    }

}
