/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ufos3;

import java.awt.Color;
import java.awt.Graphics;

/**
 *
 * @author pinter
 */
public class UFO {

    private double x;
    private double y;

    private double velx;
    private double vely;

    private Color color;

    private UFOPanel drawArea;

    private final int UFOBODY_WIDTH = 40;
    private final int UFOBODY_HEIGHT = 20;
    private final int UFOCABIN_RADIUS = 16;

    private final int VELOCITY_RANGE = 3;

    public UFO(UFOPanel drawArea) {
        this.drawArea = drawArea;
        x = Math.random() * drawArea.getWidth();
        y = Math.random() * drawArea.getHeight();
        velx = Math.random() * VELOCITY_RANGE * 2 - VELOCITY_RANGE;
        vely = Math.random() * VELOCITY_RANGE * 2 - VELOCITY_RANGE;
        color = new Color((float) Math.random(), (float) Math.random(),
                (float) Math.random());
    }

    public void draw(Graphics g) {
        g.setColor(color);
        g.fillOval((int) x, (int) y, UFOBODY_WIDTH, UFOBODY_HEIGHT);
        g.setColor(color.darker());
        g.fillOval((int) (x + (UFOBODY_WIDTH - UFOCABIN_RADIUS) / 2),
                (int) (y - UFOCABIN_RADIUS / 2), UFOCABIN_RADIUS, UFOCABIN_RADIUS);
    }

    public void move() {
        x += velx;
        y += vely;
        if (x < 0 || x + UFOBODY_WIDTH > drawArea.getWidth()) {
            velx *= -1;
        }
        if (y < 0 || y + UFOBODY_HEIGHT > drawArea.getHeight()) {
            vely *= -1;
        }
    }

    public void setPosition(double x, double y) {
        this.x = x;
        this.y = y;
    }

}
