/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ufos3;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.Timer;

/**
 *
 * @author pinter
 */
public class UFOGUI {

    private ArrayList<UFO> ufos;

    private JFrame frame;
    private UFOPanel ufoPanel;
    private JPanel buttonPanel;

    private final int DRAWAREA_WIDTH = 1000;
    private final int DRAWAREA_HEIGHT = 500;

    public UFOGUI() {
        ufos = new ArrayList<>();
        frame = new JFrame("UFOs");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        buttonPanel = new JPanel();
        int[] ufoCounts = new int[]{-1000, -100, -10, -1, 1, 10, 100, 1000};
        for (int ufoCount : ufoCounts) {
            JButton button = new JButton(String.valueOf(ufoCount));
            button.addActionListener(new AddRemoveUFOsActionListener(ufoCount));
            buttonPanel.add(button);
        }
        frame.getContentPane().add(buttonPanel, BorderLayout.SOUTH);

        ufoPanel = new UFOPanel(ufos);
        ufoPanel.setPreferredSize(new Dimension(DRAWAREA_WIDTH, DRAWAREA_HEIGHT));
        ufoPanel.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {
                
            }

            @Override
            public void mousePressed(MouseEvent e) {
                
            }

            @Override
            public void mouseReleased(MouseEvent e) {
                for (UFO ufo : ufos) {
                    ufo.setPosition(e.getX(), e.getY());
                }
            }

            @Override
            public void mouseEntered(MouseEvent e) {
                
            }

            @Override
            public void mouseExited(MouseEvent e) {
                
            }
        });
        frame.getContentPane().add(ufoPanel, BorderLayout.CENTER);
        
        Timer timer = new Timer(10, new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                for (UFO ufo : ufos) {
                    ufo.move();
                }
                ufoPanel.repaint();
            }
        });
        timer.start();        

        frame.pack();
        frame.setVisible(true);
    }

    class AddRemoveUFOsActionListener implements ActionListener {

        private int ufoCount;

        public AddRemoveUFOsActionListener(int ufoCount) {
            this.ufoCount = ufoCount;
        }

        @Override
        public void actionPerformed(ActionEvent e) {
            if (ufoCount > 0) {
                for (int i = 0; i < ufoCount; i++) {
                    ufos.add(new UFO(ufoPanel));
                }
            } else {
                for (int i = ufoCount; i < 0; i++) {
                    if (!ufos.isEmpty()) {
                        ufos.remove(ufos.size() - 1);
                    }
                }
            }
        }
    }
}
